import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.geom.Point2D;
import java.awt.*;
import javax.swing.JMenuItem;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.*;
import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import java.awt.MouseInfo;

public class MouseListener extends MouseAdapter implements ActionListener {
   private MyWorld world;
   private Drawable currentElement;
    private Drawable bola = null;
    private Drawable muralla = null;
    private PhysicsElement physical = null;
   private JPanel panel;
   private String datar = "0.2";
   private String datam = "1";
   private String datac;
   private String datal;
   private boolean elimina = false;
   private boolean comodin = false;
   private JPopupMenu popup;
   public MouseListener (MyWorld w, JPanel p){
      world = w;
      panel = p;    
   } 
   public void mouseMoved(MouseEvent e) {
      Point2D.Double p = new Point2D.Double(0,0);
      MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
      Drawable newElement = world.find(p.getX(), p.getY());	
      if (newElement == currentElement) return;
      if (currentElement != null) {
	 currentElement.setReleased();
         currentElement = null;
      }
      if (newElement != null) { 
	  bola = newElement;
	  muralla = newElement;
	  currentElement = newElement;
         currentElement.setSelected();
      }

      panel.repaint();
   }
   public void mouseDragged(MouseEvent e) {
      Point2D.Double p = new Point2D.Double(0,0);
      MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
      if (currentElement == null) return;
      currentElement.dragTo(p.getX(), p.getY());
      panel.repaint();
   }
    public void mouseReleased(MouseEvent e) {
      if (currentElement != null) 
         currentElement.setReleased();


   }
    public void mouseClicked(MouseEvent e)
      {

      Point2D.Double p = new Point2D.Double(0,0);
      MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
      Drawable newElement = world.find(p.getX(), p.getY());
      if ((newElement != null) && panel.getCursor().getType() == Cursor.CROSSHAIR_CURSOR && e.getButton() == java.awt.event.MouseEvent.BUTTON1) {
	  if (newElement instanceof PhysicsElement){
	      physical = (PhysicsElement) newElement;
	      physical.setPosition(300,300);
			physical.setEliminado(true);/*Avisa que el objeto es eliminado*/

	  }    
         panel.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
	 panel.repaint();
      }   
      if (newElement != null  && e.getButton() == java.awt.event.MouseEvent.BUTTON3) { 
	  if (newElement instanceof Ball){
	      popup = new JPopupMenu("Nuevo");
	      JMenuItem menuItem = new JMenuItem("Modifique el radio");
	      menuItem.addActionListener(this);
	      popup.add(menuItem);
	      menuItem = new JMenuItem("Modifique la masa");
	      menuItem.addActionListener(this);
	      popup.add(menuItem);
	      menuItem = new JMenuItem("Modifique el color");
	      menuItem.addActionListener(this);
	      popup.add(menuItem);
	  }
	  if (newElement instanceof Wall){
	      popup = new JPopupMenu("Nuevo");
	      JMenuItem menuItem = new JMenuItem("Modifique el largo");
	      menuItem.addActionListener(this);
	      popup.add(menuItem);
	  }
	      Point p1 = MouseInfo.getPointerInfo().getLocation();
	      popup.setLocation(p1.x,p1.y);
	      popup.setVisible(true);
      }
      }
    public void actionPerformed(ActionEvent e) {/*Parecido a lo que hace la clase WorldControlMenuListener*/
		JMenuItem menuItem = (JMenuItem)(e.getSource());
		String text = menuItem.getText();
		if (text.equals("Delete")) 
		panel.setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
		if (text.equals("Modifique el radio")) {
		    try {
			datar = JOptionPane.showInputDialog("Ingrese radio [m]");
			comodin = true;    
			popup.setVisible(false);
			if (bola instanceof Ball && comodin == true){
			    Ball newBall  = (Ball) bola;
			    newBall.setRadius(this.getRadio());
			    panel.repaint();
			    comodin = false;
			}
			popup.setVisible(false); 
		    } catch ( NumberFormatException ex) {
			popup.setVisible(false);
		    }     
		}
		if (text.equals("Modifique la masa")) {
		    try {
			datam = JOptionPane.showInputDialog("Ingrese masa [kg]");
			comodin = true;
			popup.setVisible(false);
			if (bola instanceof Ball && comodin == true){
			    Ball newBall  = (Ball) bola;
			    newBall.setMass(this.getMasa());
			    panel.repaint();
			    comodin = false;
			}
			popup.setVisible(false); 
		    } catch ( NumberFormatException ex) {
			popup.setVisible(false);
		    }     
		}
		if (text.equals("Modifique el color")) {
		    try {
			SerialTest serial = world.getSerial();
			String datac = serial.getC();
			comodin = true;
			if (bola instanceof GBall && comodin == true){
			    GBall newGBall  = (GBall) bola;
			    newGBall.setColor(this.getColor());
			    panel.repaint();
			    comodin = false;

			/*datac = JOptionPane.showInputDialog("Ingrese color en hexadecimal");
			comodin = true;
			popup.setVisible(false);
			if (bola instanceof GBall && comodin == true){
			    GBall newGBall  = (GBall) bola;
			    newGBall.setColor(this.getColor());
			    panel.repaint();
			    comodin = false;*/
			}
			popup.setVisible(false); 
		    } catch ( NumberFormatException ex) {
			datac = JOptionPane.showInputDialog("En hexadecimal!!");
			comodin = true;
			popup.setVisible(false);
			if (bola instanceof GBall && comodin == true){
			    GBall newGBall  = (GBall) bola;
			    newGBall.setColor(this.getColor());
			    panel.repaint();
			    comodin = false;
			}
			popup.setVisible(false);
     
		    }     
		}
		if (text.equals("Modifique el largo")) {
		    try{
			datal = JOptionPane.showInputDialog("Ingrese largo [m]");
			comodin = true;
			popup.setVisible(false);
			if (muralla instanceof Wall && comodin == true){
			    Wall newWall  = (Wall) muralla;
			    newWall.setLength(this.getLargo());
			    panel.repaint();
			    comodin = false;
			}
			popup.setVisible(false); 
		    } catch (NumberFormatException ex) {
			popup.setVisible(false);
		    }
		}					
    }
    public float getLargo(){
	return Float.parseFloat(datal);
    }
    public float getRadio(){
	return Float.parseFloat(datar);
    }
    public float getMasa(){
	return Float.parseFloat(datam);
    }
    public Color getColor(){
	 float aux = Float.parseFloat(datac);
	 String rgb = Float.toHexString(aux);
	rgb = rgb.substring(2, rgb.length());
	return Color.decode(rgb);
   }    
}
